;07.05.2024 8:30-8:42 start coding generate and draw 14:25-14:55 mark board algo
;08.05.2024 7:12-7:27 keyboard input 8:30-8:59 cursor move 10:35 fire handling
;09.05.2024 5:17-5:26 move count output
	device zxspectrum48
        ORG #6000
begin

board equ $B000
	ld sp,$5FFF
	call blackscr
	xor a:out ($FE),a
	ld hl,song:call stc_init_entry

	di
	ld hl,$BE00,de,$BE01,bc,257,(hl),$BF:ldir
	ld a,$C3,($BFBF),a
	ld hl,intvec,($BFBF+1),hl
	ld a,$BE,i,a
	im 2
	ei

;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir

;title
	ld ix,t_1:call tout
	ld ix,t_2:call tout
	ld ix,t_3:call tout

kb_lp:
;key S
	ld a,$FD:in a,($FE):and 2:jp z,start_play
;key C
	ld a,$FE:in a,($FE):and 8:jp z,sel_control
	jp kb_lp
sel_control:
	ld a,(ctype)
	inc a
	cp 3:jr nz,noclp
	xor a
noclp:
	ld (ctype),a
	ld l,a,h,0
	ld de,hl
	add hl,hl
	add hl,de
	ld de,controlt
	add hl,hl
	add hl,de
	ld de,t3c
	ld bc,6
	ldir
	ld ix,t_2:call tout
	call wp
	jp kb_lp
ctype:db 0 ; control type
controlt
	db "Cursor"
	db "67890 "
	db "QAOPM "

;cursor: port/bit
kbtbl:
 db $F7,16;5-left
 db $Ef,4;8-right
 db $EF,8;7-up
 db $EF,16;6-down
 db $Ef,1;0-fire
;if2 6 (left), 7 (right), 8 (down), 9 (up) and 0 (fire)
 db $EF,16;6-left
 db #EF,8;7-right
 db $EF,2;9-up
 db $EF,4;8-down
 db $EF,1;0-fire
;OPm
 db $DF,2;O-left
 db $DF,1;P-right
 db $FB,1;Q-up
 db $FD,1;A-down
 db $7F,4;M-fire
;-------------------------------------------

start_play:
	call blackscr
;tune keyboard ctype #,kbtbl
	ld hl,(ctype),h,0,de,hl
;*10
	add hl,hl;*2
	add hl,hl;*4
	add hl,de;*5
	add hl,hl;*10
	ld de,kbtbl
	add hl,de
;write data
	ld a,(hl),(klp+1),a:inc hl;left
	ld a,(hl),(klb+1),a:inc hl
	ld a,(hl),(krp+1),a:inc hl;right
	ld a,(hl),(krb+1),a:inc hl
	ld a,(hl),(kup+1),a:inc hl;up
	ld a,(hl),(kub+1),a:inc hl
	ld a,(hl),(kdp+1),a:inc hl;down
	ld a,(hl),(kdb+1),a:inc hl
	ld a,(hl),(kfp+1),a:inc hl;fire
	ld a,(hl),(kfb+1),a:inc hl

startgame:
	call blackscr
;init vars
	ld a,25,(movesc),a
	ld hl,0,(pxy),hl
	call initgame

	call markgame
	call drawgame

	call disp_move
	call putplyr
;	jp gamedone
;	jp gameend
;;;;;;;;;;;;;;;;;;; GAME LOOP ;;;;;;;;;;;;;;;;;;;
gamelp:
klp:	ld a,$F7; 5 left
	in a,($FE)
klb:	and 16
	jp nz,keyr
	ld de,(pxy)
	inc e
	dec e
	jp z,gamelp
	push de
	call charxy2,charxy
	pop de
	dec e
	ld (pxy),de
	ld c,4
scllp1
	push hl
	ld b,8
	ei:halt
scllp2
	sla (hl):dec l
	rl (hl): inc l
	sla (hl):dec l
	rl (hl): inc l

	call nbhl
	djnz scllp2
	pop hl
	dec c
	jr nz, scllp1
	jp gamelp

keyr:
krp:	ld a,$EF ; 8 right
	in a,($FE)
krb:	and 4
	jp nz,keyu
	ld de,(pxy)
	ld a,e
	cp 13
	jp z,gamelp
	push de
	call charxy2,charxy
	pop de
	inc e
	ld (pxy),de
	ld c,4
scrlp1
	push hl
	ld b,8
	ei:halt
scrlp2
	srl (hl):inc l
	rr (hl): dec l
	srl (hl):inc l
	rr (hl): dec l
	call nbhl
	djnz scrlp2
	pop hl
	dec c
	jr nz, scrlp1
	jp gamelp
keyu:
kup:	ld a,$EF ;7 up
	in a,($FE)
kub:	and 8
	jp nz,keyd
	ld de,(pxy)
	inc d
	dec d
	jp z,gamelp
	push de
	call charxy2,charxy
	pop de
	dec d
	ld (pxy),de
	ld c,8
sculp1
	push hl
	ei:halt
	call putplyr2
	pop hl
	call up_hl
	dec c
	jr nz,sculp1

	jp gamelp

keyd ; 6 down
kdp:	ld a,$EF
	in a,($FE)
kdb:	and 16
	jp nz,keyf

	ld de,(pxy)
	ld a,d
	cp 13
	jp z,gamelp
	push de
	call charxy2,charxy
	pop de
	inc d
	ld (pxy),de
	ld c,8
scdlp1
	push hl
	ei:halt
	call putplyr2
	pop hl
	call nbhl
	dec c
	jr nz,scdlp1
	jp gamelp
keyf: ;Enter
kfp:	ld a,$BF ; EF
	in a,($FE)
kfb:	and 1
	jp nz,gamelp
;check board for b7=1
	ld de,(pxy)
	call bxy
	ld c,(ix+0)
	bit 7,c
	jp nz,gamelp
;replace value to current
	ld hl,board
	ld b,14
replylp
	push bc
	ld b,14
replxlp
	bit 7,(hl)
	jr z,replnxx
	ld (hl),c
replnxx:
	res 7,(hl)
	inc hl
	djnz replxlp
	pop bc
	djnz replylp
;fill
	call markgame
;draw
	ld a,(movesc)
	dec a
	ld (movesc),a
	ei:halt
	call disp_move
	call drawgame
;check if done
	call checkgame; Z=1 if done,Z=0 if not
;	jr nz,$
	jp nz,gamedone
	call wp
	ld a,(movesc)
	or a
;	jr z,$
	jp nz,gamelp
gameend
	ld ix,endgamet
	call tout
wsp: ld a,$7F:in a,($FE):rra:jr c,wsp
	jp startgame
gamedone
scrp=$4809+4*32+2
	ld c,0
m1:
	ld de,scrp
	ld ix,msg
m2:
m3:
	ld a,(ix+0)
	inc ix
	ld h,0,l,a
	add hl,hl
	add hl,hl
	add hl,hl
	push bc
	ld bc,fnt-256
	add hl,bc
	pop bc
	push de
	ld b,8
	cp "e"
	jr nz,nodecb
	dec b
nodecb
	ld a,c
	or a
	jr z,c0
	dec a
	jr z,c1
	dec a
	jr z,c2
	dec a
	jr z,c3
nxtc:
	inc c
	bit 2,c
	jr z,nowa
	ei
	halt
nowa:
	res 2,c
	ld a,(ix+0)
	or a
	jp z,m1
	jp m3
c0:
c_0:
	ld a,(hl)
	add a,a
	ld (de),a
	inc hl
	inc d
	djnz c_0
ende:
	pop de
	inc e
	ld a,$7F:in a,($FE)
	rra:jp nc,startgame
	jr nxtc
c1:
	inc hl
	jr c_3
c2:
c_2:
	ld a,(hl)
	srl a
	ld (de),a
	inc hl
	call nbde
	djnz c_2
	xor a
	ld (de),a
	jr ende
c3:
	xor a
	ld (de),a
	inc d
c_3:
	ld a,(hl)
	ld (de),a
	inc hl
	call nbde
	djnz c_3
	jr ende
nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
msg:
 db "well done! ",0
;-------- R O U T I N E S --------
checkgame ; Z=1 if not done,Z=0 if yes
	ld hl,board
	ld c,14
cgylp
	ld b,14
cgxlp
	bit 7,(hl):ret z
	inc hl
	djnz cgxlp
	dec c:jr nz,cgylp
	ld a,1:or a
	ret
wp: xor a:in a,($FE):cpl:and 31:jr nz,wp
	ret
putplyr
	ld de,(pxy)
;	ld a,e:add a,9:ld e,a
;	ld a,d:add a,5:ld d,a
	call charxy2
	call charxy
putplyr2
	ld de,plyr
	ld b,8
pplp:
	ld a,(de),(hl),a
	inc de
	call nbhl
	djnz pplp
	ret

nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET

up_hl:
     LD A,H
     DEC H
     AND 7
     ret nz
     LD A,L
     SUB 32
     LD L,A
     ret c
     LD A,H
     ADD A,8
     LD H,A
 ret

blackscr
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr:ret

charxy2
	ld a,e:add a,9:ld e,a
	ld a,d:add a,5:ld d,a
	ret
charxy ;in: D=y,E=x, out: HL=screen address
	push de
	ld	hl, 4000h
	ld	a, d
	and	18h
	or	h
	ld	h, a
	ld	a, d
	and	7
	ld	d, a
	srl	d
	rr	l
	srl	d
	rr	l
	srl	d
	rr	l
	add	hl, de
	pop de
	ret


markgame
;	jr $
	ld de,0
	ld ix,board
	ld a,(ix+0)
	and 127
	ld c,a
	call ma
	ret
ma
	call bxy
	set 7,(ix+0)
;X<>0
	inc e
	dec e
	jr z,skipt11
;	dec e
	call bxy
	ld a,(ix-1)
	bit 7,a
	jr nz,skipt12
	and 127
	cp c
	jr nz,skipt12
	push de
	dec e
	call ma
	pop de
skipt12
;	inc e
skipt11
;X<>14
	ld a,e
	cp 14
	jr z,skipt21
;	inc e
	call bxy
	ld a,(ix+1)
	bit 7,a
	jr nz,skipt22
	and 127
	cp c
	jr nz,skipt22
	push de
	inc e
	call ma
	pop de
skipt22
;	dec e
skipt21
;Y<>0
	inc d
	dec d
	jr z,skipt31
;	dec d
	call bxy
	ld a,(ix-14)
	bit 7,a
	jr nz,skipt32
	and 127
	cp c
	jr nz,skipt32
	push de
	dec d
	call ma
	pop de
skipt32
;	inc d
skipt31
;Y<>14
	ld a,d
	cp 14
	jr z,skipt41
;	inc d
	call bxy
	ld a,(ix+14)
	bit 7,a
	jr nz,skipt42
	and 127
	cp c
	jr nz,skipt42
	push de
	inc d
	call ma
	pop de
skipt42
;	dec d
skipt41
	ret

bxy
;in: D.E=y.x,out: HL= board address
	push bc,de,hl
	ld l,d,h,0
	add hl,hl ;*2
	ld bc,hl
	add hl,hl ;*4
	add hl,hl ;*8
	add hl,hl ;*16
	or a
	sbc hl,bc; *14
	ld d,0
	add hl,de
	ld bc,board
	add hl,bc
	push hl
	pop ix
	pop hl,de,bc
	ret

initgame
	ld hl,board
	ld b,14
igylp
	push bc
	ld b,14
igxlp
	call random
rr
	sub 6
	jr nc,rr
	add a,7
	ld (hl),a
	inc hl
	djnz igxlp
	pop bc
	djnz igylp
;	ld hl,board
;	set 7,(hl)
	ret
drawgame
	ld de,board
	ld hl,$5800+5*32+9
	ld b,14
dgylp
	push bc
	push hl
	ld b,14
dgxlp
	ld a,(de)
	inc de
;
;	bit 7,a:jr z,noflash
;	or 16
;noflash:
;
	add a,a
	add a,a
	add a,a
	cp 48
	jr z,noink
	or 7
noink
	ld (hl),a
	inc hl
	djnz dgxlp
	pop hl
	ld bc,32
	add hl,bc
	pop bc
	djnz dgylp
	ret

random  PUSH BC:LD A,(R1),C,A
        LD A,(R2):ADD A,C:LD C,A
        LD (R1),A,A,(R3)
        SUB C:LD C,A,(R2),A
        RRCA:LD (R3),A
        LD A,C:POP BC
        RET
R1      DB #15
R2      DB #70
R3      DB #FD

disp_move
	ld a,(movesc)
	ld c,47
dmlp:
	inc c
	sub 10
	jr nc,dmlp
	add a,58
	ld (mtt+1),a
	ld a,c
	ld (mtt),a
	ld ix,movt
	call tout
	ret
movt
 dw $4000+9+4*32
 db 7
mtt: db "00/25",$ff
tout: ;in:IX=address of message
	ld e,(ix+0):inc ix
	ld d,(ix+0):inc ix
	ld c,#47
tolp1:
	ld a,(ix+0):inc ix
	cp $ff:ret z
	cp 8:jr nc, putchar
	or $40
	ld c,a
	jr tolp1
putchar:
	ld l,a,h,0
	push bc
	ld bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	pop bc
	ld b,8
	push de
tolp2:
	ld a,(hl),(de),a:inc hl,d:djnz tolp2
	pop de
;put attribute
	ld l,e
;$40=01 000 000 $58=01011 000
;$48=01 001 000 $59=01011 001
;$50=01 010 000 $5A=01011 010
	ld a,d
	srl a
	srl a
	srl a
	and 7
	add a,$58
	ld h,a
	ld (hl),c
	inc e
	jr tolp1

intvec:
	push ix
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL stc_play_entry
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop ix
	ei:ret

endgamet
	dw $4809+4*32+2
	db "Game Over!",$FF
playr:include "stc_player.a80"
song: incbin "tune.STC"
fnt incbin "floodit.fnt"

t_1:
	dw $4004
	db 6,"floodit! ",7,"g0blinish ",4,"2o24",$FF
t_2:
	dw $4809
	db 7,"C",4,"ontrol:",6
t3c db "Cursor",$FF

t_3:
	dw $482B
	db 7,"S",4,"tart game",$FF

;-------- V A R S --------
movesc db 0 ; moves count
pxy dw 0 ; player XY

plyr
	db %00000000
	db %00000000
	db %01111100
	db %11111110
	db %11111110
	db %11111110
	db %01111100
	db %00000000
end
	display /d,end-begin
	savesna "floodit.sna",begin
	savebin "floodit.code",begin,end-begin
